%% ------------------------------------------------------------------------- %% \\
\chapter{Contributions to Industrial I/O subsystem of Linux}
\label{att:contribIIO}

\section{Development environment configuration activities}

\subsection{Basic Setup}

\textbf{Setup e-mail client:} This step consists of installing and configuring an e-mail client that allows the use of the terminal to send contributions managed by git version control system. The customer selected was Neomutt\footnote{\url{https://neomutt.org/}}.

\textbf{Join the IRC channel of the selected project:} Here is the place for quickly discussions and questions/answers with others active developers. 

\textbf{Clone the kernel git repository:} Because each maintainer has a commit tree to accept works related to a particular subsystem, the contributor must keep the selected subsystem maintainer tree up to date.

\textbf{Install a virtual machine for development:} it prevents that, by some carelessness, the contributor damages its operating system. This care is necessary because by modifying and compiling a Linux image, the developer can replace the image of his/her system and insert a critical bug.

\textbf{Learning how to modify, compile, and install a Linux kernel image:} consists of a series of commands and settings that need to be executed or updated to perform proposed work.

\subsection{Understanding the process of sending contribution}

\textbf{Learn Linux kernel development process documentation:} \url{https://www.kernel.org/doc/html/v4.15/process/2.Process.html}

\textbf{Learn the Linux code style:} \url{https://www.kernel.org/doc/html/v4.10/process/coding-style.html}

\textbf{Execute tutorials to introduce newcomers to the contribution flow:} \url{https://kernelnewbies.org/FirstKernelPatch}

\section{Contributions sent to the IIO subsystem (patches)}

Contributions sent to the Industrial I / O subsystem

\begin{table}[]
\centering
\resizebox{\textwidth}{!}{\begin{tabular}{  | m{2.5cm} | m{6cm} | m{2.5cm} | m{3cm} | m{2cm} | m{2cm} |  }
\hline
\textbf{1st Version Date} & \textbf{Commit message} & \textbf{Developer(s)} & \textbf{Kind of change} & \textbf{\# Versions} & \textbf{Status} \\ \hline
Apr 2, 2019 & staging: iio: frequency: ad9834: Remove unnecessary parentheses & Melissa Wen & Code style & 1 & Merged \\ \hline
May 3, 2019 & staging: iio: ad7150: organize registers definition & Melissa Wen & Improve readability & 1 & Declined \\ \hline
May 3, 2019 & staging: iio: ad7150: use FIELD\_GET and GENMASK & Melissa Wen & Improve maintanability & 2 & Merged \\ \hline
May 3, 2019 & staging: iio: ad7150: simplify i2c SMBus return treatment & Melissa Wen & Reduce verbosity & 2 & Merged \\ \hline
May 3, 2019 & staging: iio: ad7150: clean up of comments & Melissa Wen & Improve readability & 2 & Merged \\ \hline
May 18, 2019 & staging: iio: cdc: ad7150: create of\_device\_id array & Barbara Fernandes, Wilson Sales Melissa Wen & Create missing element & 1 & Merged \\ \hline
May 18, 2019 & staging:iio:ad7150: fix threshold mode config bit & Melissa Wen & Bug fix & 1 & Merged \\ \hline
Jun 14, 2019 & staging: iio: ad7150: use ternary operating to ensure 0/1 value & Melissa Wen & Remove idiom, Make operation consistent & 1 & Merged \\ \hline
\end{tabular}%
}
\caption{List of contributions sent to IIO Linux subsystem}
\label{tab:patcheslist}
\end{table}

\section{Anatomy and contribution flow: the case of [PATCH] staging:iio:ad7150: fix threshold mode config bit}

Proposing a code change involves a series of interactions. Each patch
submission improves the acquaintance with processes, standards established,
communication style among members, and roles played by each in the process of
code review and merging.

\subsection{Sending a contribution by e-mail}

\textbf{Header Information}

Date: 18 de maio de 2019 22:04 \\
From: Melissa Wen $<$melissa.srw@gmail.com$>$ \\
To: Lars-Peter Clausen $<$lars@metafoo.de$>$, Michael Hennerich $<$Michael.Hennerich@analog.com$>$, Stefan Popa $<$stefan.popa@analog.com$>$, Jonathan Cameron $<$jic23@kernel.org$>$, Hartmut Knaack $<$knaack.h@gmx.de$>$, Peter Meerwald-Stadler $<$pmeerw@pmeerw.net$>$, Greg Kroah-Hartman $<$gregkh@linuxfoundation.org$>$, Barry Song $<$21cnbao@gmail.com$>$ \\
Cc: linux-iio@vger.kernel.org, devel@driverdev.osuosl.org, linux-kernel@vger.kernel.org, kernel-usp@googlegroups.com \\

\textbf{Change Description}

According to the AD7150 configuration register description, bit 7 assumes \\
value 1 when the threshold mode is fixed and 0 when it is adaptive, \\
however, the operation that identifies this mode was considering the \\
opposite values. \\
 \\
This patch renames the boolean variable to describe it correctly and \\
properly replaces it in the places where it is used. \\

\textbf{Special Tags}
Fixes: 531efd6aa0991 ("staging:iio:adc:ad7150: chan\_spec conv + i2c\_smbus commands + drop unused poweroff timeout control.") \\

\textbf{Commit Author(s)}
Signed-off-by: Melissa Wen $<$melissa.srw@gmail.com$>$ \\

\textbf{Commit Diff}
--- \\
 drivers/staging/iio/cdc/ad7150.c | 19 +++++++++++-------- \\
 1 file changed, 11 insertions(+), 8 deletions(-) \\
 \\
diff --git a/drivers/staging/iio/cdc/ad7150.c b/drivers/staging/iio/cdc/ad7150.c \\
index dd7fcab8e19e..e075244c602b 100644 \\
--- a/drivers/staging/iio/cdc/ad7150.c \\
+++ b/drivers/staging/iio/cdc/ad7150.c \\
@@ -5,6 +5,7 @@ \\
  * Copyright 2010-2011 Analog Devices Inc. \\
  */ \\
 \\
+\#include $<$linux/bitfield.h$>$ \\
 \#include $<$linux/interrupt.h$>$ \\
 \#include $<$linux/device.h$>$ \\
 \#include $<$linux/kernel.h$>$ \\
@@ -130,7 +131,7 @@ static int ad7150\_read\_event\_config(struct iio\_dev *indio\_dev, \\
 \{ \\
        int ret; \\
        u8 threshtype; \\
-       bool adaptive; \\
+       bool thrfixed; \\
        struct ad7150\_chip\_info *chip = iio\_priv(indio\_dev); \\
 \\
        ret = i2c\_smbus\_read\_byte\_data(chip-$>$client, AD7150\_CFG); \\
@@ -138,21 +139,23 @@ static int ad7150\_read\_event\_config(struct iio\_dev *indio\_dev, \\
                return ret; \\
 \\
        threshtype = (ret $>$$>$ 5) \& 0x03; \\
-       adaptive = !!(ret \& 0x80); \\
+ \\
+       /*check if threshold mode is fixed or adaptive*/ \\
+       thrfixed = FIELD\_GET(AD7150\_CFG\_FIX, ret); \\
 \\
        switch (type) \{ \\
        case IIO\_EV\_TYPE\_MAG\_ADAPTIVE: \\
                if (dir == IIO\_EV\_DIR\_RISING) \\
-                       return adaptive \&\& (threshtype == 0x1); \\
-               return adaptive \&\& (threshtype == 0x0); \\
+                       return !thrfixed \&\& (threshtype == 0x1); \\
+               return !thrfixed \&\& (threshtype == 0x0); \\
        case IIO\_EV\_TYPE\_THRESH\_ADAPTIVE: \\
                if (dir == IIO\_EV\_DIR\_RISING) \\
-                       return adaptive \&\& (threshtype == 0x3); \\
-               return adaptive \&\& (threshtype == 0x2); \\
+                       return !thrfixed \&\& (threshtype == 0x3); \\
+               return !thrfixed \&\& (threshtype == 0x2); \\
        case IIO\_EV\_TYPE\_THRESH: \\
                if (dir == IIO\_EV\_DIR\_RISING) \\
-                       return !adaptive \&\& (threshtype == 0x1); \\
-               return !adaptive \&\& (threshtype == 0x0); \\
+                       return thrfixed \&\& (threshtype == 0x1); \\
+               return thrfixed \&\& (threshtype == 0x0); \\
        default: \\
                break; \\
        \} \\
--  \\
2.20.1 \\

\subsection{Receiving feedback on mailing-list}

\subsubsection{From maintainer}

\textbf{Header Information}

Date: 19 de maio de 2019 07:29 \\
From: Jonathan Cameron $<$jic23@kernel.org$>$ \\
To: Melissa Wen $<$melissa.srw@gmail.com$>$ \\
Cc: Lars-Peter Clausen $<$lars@metafoo.de$>$, Michael Hennerich $<$Michael.Hennerich@analog.com$>$, Stefan Popa $<$stefan.popa@analog.com$>$, Hartmut Knaack $<$knaack.h@gmx.de$>$, Peter Meerwald-Stadler $<$pmeerw@pmeerw.net$>$, Greg Kroah-Hartman $<$gregkh@linuxfoundation.org$>$, Barry Song $<$21cnbao@gmail.com$>$, linux-iio@vger.kernel.org, devel@driverdev.osuosl.org, linux-kernel@vger.kernel.org, kernel-usp@googlegroups.com \\

\textbf{Comments inline}
On Sat, 18 May 2019 22:04:56 -0300 \\
Melissa Wen $<$melissa.srw@gmail.com$>$ wrote: \\
$>$ According to the AD7150 configuration register description, bit 7 assumes \\
$>$ value 1 when the threshold mode is fixed and 0 when it is adaptive, \\
$>$ however, the operation that identifies this mode was considering the \\
$>$ opposite values. \\
$>$  \\
$>$ This patch renames the boolean variable to describe it correctly and \\
$>$ properly replaces it in the places where it is used. \\
$>$  \\
$>$ Fixes: 531efd6aa0991 ("staging:iio:adc:ad7150: chan\_spec conv + i2c\_smbus commands + drop unused poweroff timeout control.") \\
$>$ Signed-off-by: Melissa Wen $<$melissa.srw@gmail.com$>$ \\
 \\
Looks good to me.  Applied to the fixes-togreg branch of iio.git pushed out as \\
as testing-fixes for the autobuilders to see if they can find anything \\
we have missed. \\
 \\
Thanks, \\
 \\
Jonathan \\

\subsubsection{From an employee of the device driver company}


\textbf{Header Information}
Date: 20 de maio de 2019 06:59 \\
From: Alexandru Ardelean $<$ardeleanalex@gmail.com$>$	 \\
To: Jonathan Cameron $<$jic23@kernel.org$>$ \\
Cc: Melissa Wen $<$melissa.srw@gmail.com$>$, Lars-Peter Clausen $<$lars@metafoo.de$>$, Michael Hennerich $<$Michael.Hennerich@analog.com$>$, Stefan Popa $<$stefan.popa@analog.com$>$, Hartmut Knaack $<$knaack.h@gmx.de$>$, Peter Meerwald-Stadler $<$pmeerw@pmeerw.net$>$, Greg Kroah-Hartman $<$gregkh@linuxfoundation.org$>$, Barry Song $<$21cnbao@gmail.com$>$, linux-iio@vger.kernel.org, devel@driverdev.osuosl.org, LKML $<$linux-kernel@vger.kernel.org$>$, kernel-usp@googlegroups.com, Alexandru Ardelean $<$alexandru.ardelean@analog.com$>$ \\

\textbf{Comments inline}
On Sun, May 19, 2019 at 8:38 PM Jonathan Cameron $<$jic23@kernel.org$>$ wrote: \\
$>$ \\
$>$ On Sat, 18 May 2019 22:04:56 -0300 \\
$>$ Melissa Wen $<$melissa.srw@gmail.com$>$ wrote: \\
\[...\] \\
$>$ $>$       threshtype = (ret $>$$>$ 5) \& 0x03; \\
$>$ $>$ -     adaptive = !!(ret \& 0x80); \\
$>$ $>$ + \\
$>$ $>$ +     /*check if threshold mode is fixed or adaptive*/ \\
$>$ $>$ +     thrfixed = FIELD\_GET(AD7150\_CFG\_FIX, ret); \\
 \\
nitpick: i would have kept the original variable name as "adaptive", \\
mostly for consistency. \\
"adaptive" is used in other places as well; \\
 \\
as i recall, the fix is just oneliner in this case: \\
 \\
- adaptive = !!(ret \& 0x80); \\
+ adaptive = !(ret \& 0x80); \\
 \\

\subsection{Receiving notification of merge}

\subsubsection{From Linux maintree maintainer}

Date: 17 de junho de 2019 17:32\\
From: gregkh@linuxfoundation.org $<$gregkh@linuxfoundation.org$>$	\\
To: melissa.srw@gmail.com, Jonathan.Cameron@huawei.com\\
\\
This is a note to let you know that I've just added the patch titled\\
\\
    staging:iio:ad7150: fix threshold mode config bit\\
\\
to my staging git tree which can be found at\\
    git://git.kernel.org/pub/scm/linux/kernel/git/gregkh/staging.git\\
in the staging-linus branch.\\
\\
The patch will show up in the next release of the linux-next tree\\
(usually sometime within the next 24 hours during the week.)\\
\\
The patch will hopefully also be merged in Linus's tree for the\\
next -rc kernel release.\\
\\
If you have any questions about this process, please let me know.\\
\\
\\
From df4d737ee4d7205aaa6275158aeebff87fd14488 Mon Sep 17 00:00:00 2001\\
From: Melissa Wen $<$melissa.srw@gmail.com$>$\\
Date: Sat, 18 May 2019 22:04:56 -0300\\
Subject: staging:iio:ad7150: fix threshold mode config bit\\
\\
According to the AD7150 configuration register description, bit 7 assumes\\
value 1 when the threshold mode is fixed and 0 when it is adaptive,\\
however, the operation that identifies this mode was considering the\\
opposite values.\\
\\
This patch renames the boolean variable to describe it correctly and\\
properly replaces it in the places where it is used.\\
\\
Fixes: 531efd6aa0991 ("staging:iio:adc:ad7150: chan\_spec conv + i2c\_smbus commands + drop unused poweroff timeout control.")\\
Signed-off-by: Melissa Wen $<$melissa.srw@gmail.com$>$\\
Signed-off-by: Jonathan Cameron $<$Jonathan.Cameron@huawei.com$>$\\
---\\
 drivers/staging/iio/cdc/ad7150.c | 19 +++++++++++--------\\
 1 file changed, 11 insertions(+), 8 deletions(-)\\
\\
diff --git a/drivers/staging/iio/cdc/ad7150.c b/drivers/staging/iio/cdc/ad7150.c\\
index dd7fcab8e19e..e075244c602b 100644\\
--- a/drivers/staging/iio/cdc/ad7150.c\\
+++ b/drivers/staging/iio/cdc/ad7150.c\\
@@ -5,6 +5,7 @@\\
  * Copyright 2010-2011 Analog Devices Inc.\\
  */\\
\\
+\#include $<$linux/bitfield.h$>$\\
 \#include $<$linux/interrupt.h$>$\\
 \#include $<$linux/device.h$>$\\
 \#include $<$linux/kernel.h$>$\\
@@ -130,7 +131,7 @@ static int ad7150\_read\_event\_config(struct iio\_dev *indio\_dev,\\
 {\\
        int ret;\\
        u8 threshtype;\\
-       bool adaptive;\\
+       bool thrfixed;\\
        struct ad7150\_chip\_info *chip = iio\_priv(indio\_dev);\\
\\
        ret = i2c\_smbus\_read\_byte\_data(chip-$>$client, AD7150\_CFG);\\
@@ -138,21 +139,23 @@ static int ad7150\_read\_event\_config(struct iio\_dev *indio\_dev,\\
                return ret;\\
\\
        threshtype = (ret $>$$>$ 5) \& 0x03;\\
-       adaptive = !!(ret \& 0x80);\\
+\\
+       /*check if threshold mode is fixed or adaptive*/\\
+       thrfixed = FIELD\_GET(AD7150\_CFG\_FIX, ret);\\
\\
        switch (type) {\\
        case IIO\_EV\_TYPE\_MAG\_ADAPTIVE:\\
                if (dir == IIO\_EV\_DIR\_RISING)\\
-                       return adaptive \&\& (threshtype == 0x1);\\
-               return adaptive \&\& (threshtype == 0x0);\\
+                       return !thrfixed \&\& (threshtype == 0x1);\\
+               return !thrfixed \&\& (threshtype == 0x0);\\
        case IIO\_EV\_TYPE\_THRESH\_ADAPTIVE:\\
                if (dir == IIO\_EV\_DIR\_RISING)\\
-                       return adaptive \&\& (threshtype == 0x3);\\
-               return adaptive \&\& (threshtype == 0x2);\\
+                       return !thrfixed \&\& (threshtype == 0x3);\\
+               return !thrfixed \&\& (threshtype == 0x2);\\
        case IIO\_EV\_TYPE\_THRESH:\\
                if (dir == IIO\_EV\_DIR\_RISING)\\
-                       return !adaptive \&\& (threshtype == 0x1);\\
-               return !adaptive \&\& (threshtype == 0x0);\\
+                       return thrfixed \&\& (threshtype == 0x1);\\
+               return thrfixed \&\& (threshtype == 0x0);\\
        default:\\
                break;\\
        }\\
-- \\
2.22.0

\subsubsection{From Linux version maintainer}

Sasha Levin $<$sashal@kernel.org$>$	26 de junho de 2019 21:29\\
Para: linux-kernel@vger.kernel.org, stable@vger.kernel.org\\
Cc: Melissa Wen $<$melissa.srw@gmail.com$>$, Jonathan Cameron $<$Jonathan.Cameron@huawei.com$>$, Sasha Levin $<$sashal@kernel.org$>$, linux-iio@vger.kernel.org, devel@driverdev.osuosl.org\\
From: Melissa Wen $<$melissa.srw@gmail.com$>$\\


$[$ Upstream commit df4d737ee4d7205aaa6275158aeebff87fd14488 $]$\\

According to the AD7150 configuration register description, bit 7 assumes\\
value 1 when the threshold mode is fixed and 0 when it is adaptive,\\
however, the operation that identifies this mode was considering the\\
opposite values.\\
\\
This patch renames the boolean variable to describe it correctly and\\
properly replaces it in the places where it is used.\\
\\
Fixes: 531efd6aa0991 ("staging:iio:adc:ad7150: chan\_spec conv + i2c\_smbus commands + drop unused poweroff timeout control.")\\
Signed-off-by: Melissa Wen $<$melissa.srw@gmail.com$>$\\
Signed-off-by: Jonathan Cameron $<$Jonathan.Cameron@huawei.com$>$\\
Signed-off-by: Sasha Levin $<$sashal@kernel.org$>$\\
---\\
 drivers/staging/iio/cdc/ad7150.c | 19 +++++++++++--------\\
 1 file changed, 11 insertions(+), 8 deletions(-)\\
\\
diff --git a/drivers/staging/iio/cdc/ad7150.c b/drivers/staging/iio/cdc/ad7150.c\\
index 24f74ce60f80..14596aa7eaf1 100644\\
--- a/drivers/staging/iio/cdc/ad7150.c\\
+++ b/drivers/staging/iio/cdc/ad7150.c\\
@@ -6,6 +6,7 @@\\
  * Licensed under the GPL-2 or later.\\
  */\\
\\
+\#include $<$linux/bitfield.h$>$\\
 \#include $<$linux/interrupt.h$>$\\
 \#include $<$linux/device.h$>$\\
 \#include $<$linux/kernel.h$>$\\
@@ -131,7 +132,7 @@ static int ad7150\_read\_event\_config(struct iio\_dev *indio\_dev,\\
 {\\
        int ret;\\
        u8 threshtype;\\
-       bool adaptive;\\
+       bool thrfixed;\\
        struct ad7150\_chip\_info *chip = iio\_priv(indio\_dev);\\
\\
        ret = i2c\_smbus\_read\_byte\_data(chip-$>$client, AD7150\_CFG);\\
@@ -139,21 +140,23 @@ static int ad7150\_read\_event\_config(struct iio\_dev *indio\_dev,\\
                return ret;\\
\\
        threshtype = (ret $>$$>$ 5) \& 0x03;\\
-       adaptive = !!(ret \& 0x80);\\
+\\
+       /*check if threshold mode is fixed or adaptive*/\\
+       thrfixed = FIELD\_GET(AD7150\_CFG\_FIX, ret);\\
\\
        switch (type) {\\
        case IIO\_EV\_TYPE\_MAG\_ADAPTIVE:\\
                if (dir == IIO\_EV\_DIR\_RISING)\\
-                       return adaptive \&\& (threshtype == 0x1);\\
-               return adaptive \&\& (threshtype == 0x0);\\
+                       return !thrfixed \&\& (threshtype == 0x1);\\
+               return !thrfixed \&\& (threshtype == 0x0);\\
        case IIO\_EV\_TYPE\_THRESH\_ADAPTIVE:\\
                if (dir == IIO\_EV\_DIR\_RISING)\\
-                       return adaptive \&\& (threshtype == 0x3);\\
-               return adaptive \&\& (threshtype == 0x2);\\
+                       return !thrfixed \&\& (threshtype == 0x3);\\
+               return !thrfixed \&\& (threshtype == 0x2);\\
        case IIO\_EV\_TYPE\_THRESH:\\
                if (dir == IIO\_EV\_DIR\_RISING)\\
-                       return !adaptive \&\& (threshtype == 0x1);\\
-               return !adaptive \&\& (threshtype == 0x0);\\
+                       return thrfixed \&\& (threshtype == 0x1);\\
+               return thrfixed \&\& (threshtype == 0x0);\\
        default:\\
                break;\\
        }\\
-- \\
2.20.1
